support sysvinit scripts for the syslog forwarderssusefix
.*.sw? |
file.absent | file.absent | ||||
{% endfor %} | {% endfor %} | ||||
{% if pillar.get('nginx', {}).get('use_upstart', true) %} | |||||
{% set logger_types = ('access', 'error') %} | |||||
{% for log_type in logger_types %} | |||||
/var/log/nginx/{{ log_type }}.log: | |||||
file.absent | |||||
nginx-logger-{{ log_type }}: | |||||
file: | |||||
- managed | |||||
- name: /etc/init/nginx-logger-{{ log_type }}.conf | |||||
- template: jinja | |||||
- user: root | |||||
- group: root | |||||
- mode: 440 | |||||
- source: salt://nginx/templates/upstart-logger.jinja | |||||
- context: | |||||
type: {{ log_type }} | |||||
service: | |||||
- running | |||||
- enable: True | |||||
- require: | |||||
- file: nginx-logger-{{ log_type }} | |||||
- require_in: | |||||
- service: nginx | |||||
{% endfor %} | |||||
/etc/logrotate.d/nginx: | |||||
file: | |||||
- absent | |||||
{% endif %} | |||||
/etc/nginx: | /etc/nginx: | ||||
file.directory: | file.directory: | ||||
- user: root | - user: root |
include: | include: | ||||
- nginx.common | - nginx.common | ||||
{% if pillar.get('nginx', {}).get('use_upstart', true) %} | |||||
- nginx.upstart | |||||
{% elif pillar.get('nginx', {}).get('use_sysvinit', true) %} | |||||
- nginx.sysvinit | |||||
{% endif %} | |||||
{% if pillar.get('nginx', {}).get('user_auth_enabled', true) %} | {% if pillar.get('nginx', {}).get('user_auth_enabled', true) %} | ||||
- nginx.users | - nginx.users | ||||
{% endif %} | {% endif %} |
{% set logger_types = ('access', 'error') %} | |||||
{% for log_type in logger_types %} | |||||
/var/log/nginx/{{ log_type }}.log: | |||||
file.absent | |||||
nginx-logger-{{ log_type }}: | |||||
file: | |||||
- managed | |||||
- name: /etc/init.d/nginx-logger-{{ log_type }} | |||||
- template: jinja | |||||
- user: root | |||||
- group: root | |||||
- mode: 755 | |||||
- source: salt://nginx/templates/sysvinit-logger.jinja | |||||
- context: | |||||
type: {{ log_type }} | |||||
service: | |||||
- running | |||||
- enable: True | |||||
- require: | |||||
- file: nginx-logger-{{ log_type }} | |||||
- require_in: | |||||
- service: nginx | |||||
cmd: | |||||
- wait | |||||
- name: /usr/sbin/update-rc.d nginx-logger-{{ log_type }} defaults | |||||
{% endfor %} | |||||
/etc/logrotate.d/nginx: | |||||
file.absent |
#!/bin/bash | |||||
# /etc/init.d/nginx-logger-{{ type }} | |||||
# | |||||
NAME=nginx-logger-{{ type }} | |||||
DESC="syslog forwarder for nginx {{type}} logs" | |||||
DAEMON=/usr/bin/logger | |||||
DAEMON_ARGS=" -f /var/log/nginx/{{ type }}.fifo -t nginx -p {% if type == 'error' %}warn{% else %}debug{% endif %}" | |||||
PIDFILE=/var/run/$NAME.pid | |||||
SCRIPTNAME=/etc/init.d/$NAME | |||||
# Exit if the daemon program isn't installed | |||||
[ -x "$DAEMON" ] || exit 0 | |||||
# Read configuration variable file if it is present | |||||
[ -r /etc/default/$NAME ] && . /etc/default/$NAME | |||||
. /lib/lsb/init-functions | |||||
do_start() { | |||||
# Return | |||||
# 0 if daemon has been started | |||||
# 1 if daemon was already running | |||||
# 2 if daemon could not be started | |||||
pid=$(pidofproc -p $PIDFILE $DAEMON) | |||||
if [ -n "$pid" ]; then | |||||
return 1; | |||||
fi | |||||
if [ ! -r /var/log/nginx/{{ type }}.fifo ]; then | |||||
mkdir -p /var/log/nginx | |||||
mkfifo /var/log/nginx/{{ type }}.fifo | |||||
chown root.root /var/log/nginx/{{ type }}.fifo | |||||
chmod 660 /var/log/nginx/{{ type }}.fifo | |||||
fi | |||||
start-stop-daemon --start --quiet --background --pidfile $PIDFILE --exec $DAEMON -- $DAEMON_ARGS | |||||
} | |||||
do_stop() { | |||||
# Return | |||||
# 0 if daemon has been stopped | |||||
# 1 if daemon was already stopped | |||||
# 2 if daemon could not be stopped | |||||
# other if a failure occurred | |||||
pids=$(pidof -x $DAEMON) | |||||
if [ $? -eq 0 ]; then | |||||
echo $pids | xargs kill 2&1>/dev/null | |||||
RETVAL=0 | |||||
else | |||||
RETVAL=1 | |||||
fi | |||||
[ "$RETVAL" = 2 ] && return 2 | |||||
rm -f $PIDFILE | |||||
return "$RETVAL" | |||||
} | |||||
case "$1" in | |||||
start) | |||||
[ "$VERBOSE" != no ] && log_daemon_msg "Starting $DESC" "$NAME" | |||||
do_start | |||||
case "$?" in | |||||
0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;; | |||||
2) [ "$VERBOSE" != no ] && log_end_msg 1 ;; | |||||
esac | |||||
;; | |||||
stop) | |||||
[ "$VERBOSE" != no ] && log_daemon_msg "Stopping $DESC" "$NAME" | |||||
do_stop | |||||
case "$?" in | |||||
0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;; | |||||
2) [ "$VERBOSE" != no ] && log_end_msg 1 ;; | |||||
esac | |||||
;; | |||||
status) | |||||
status_of_proc "$DAEMON" "$NAME" && exit 0 || exit $? | |||||
;; | |||||
restart|force-reload) | |||||
[ "$VERBOSE" != no ] && log_daemon_msg "Restarting $DESC" "$NAME" | |||||
do_stop | |||||
case "$?" in | |||||
0|1) | |||||
do_start | |||||
case "$?" in | |||||
0) log_end_msg 0 ;; | |||||
1) log_end_msg 1 ;; # Old process still running | |||||
*) log_end_msg 1 ;; # Failed to start | |||||
esac | |||||
;; | |||||
*) | |||||
# Failed to stop | |||||
log_end_msg 1 | |||||
;; | |||||
esac | |||||
;; | |||||
*) | |||||
echo "Usage: /etc/init.d/nginx-logger-{{ type }} {start|stop|status|restart|force-reload}" >&2 | |||||
exit 3 | |||||
;; | |||||
esac | |||||
exit 0 |
{% set logger_types = ('access', 'error') %} | |||||
{% for log_type in logger_types %} | |||||
/var/log/nginx/{{ log_type }}.log: | |||||
file.absent | |||||
nginx-logger-{{ log_type }}: | |||||
file: | |||||
- managed | |||||
- name: /etc/init/nginx-logger-{{ log_type }}.conf | |||||
- template: jinja | |||||
- user: root | |||||
- group: root | |||||
- mode: 440 | |||||
- source: salt://nginx/templates/upstart-logger.jinja | |||||
- context: | |||||
type: {{ log_type }} | |||||
service: | |||||
- running | |||||
- enable: True | |||||
- require: | |||||
- file: nginx-logger-{{ log_type }} | |||||
- require_in: | |||||
- service: nginx | |||||
{% endfor %} | |||||
/etc/logrotate.d/nginx: | |||||
file.absent |
nginx: | nginx: | ||||
install_from_source: True | install_from_source: True | ||||
use_upstart: True | use_upstart: True | ||||
use_sysvinit: False | |||||
user_auth_enabled: True | user_auth_enabled: True | ||||
with_luajit: False | with_luajit: False | ||||
with_openresty: True | with_openresty: True |